#!/bin/bash

echo "USAGE: ./OC20_upgrade.sh IP Username Password"

getloginid()
{
  if [ "$1" == "" ] ; then
    echo 1>&2 "$usage"; exit 1 ;
  fi

  if [ "$2" == "" ] ; then
    USERNAME="admin"
  else
    USERNAME=$2
  fi

  if [ "$3" == "" ] ; then
    PASSWORD="admin"
  else
    PASSWORD=$3
  fi

  ADDRESS=$1
  curl -s -L -k -d "opcode=login&user=${USERNAME}&passwd=${PASSWORD}" "https://${ADDRESS}:4343/swarm.cgi" | cut -c 53-72
}

ADDRESS=$1
OPERATION='open'
USER=$2
PASSWORD=$3

if [ "$2" == "" ] ; then
   USER="admin"
   PASSWORD="admin"
fi

SID=`getloginid $ADDRESS $USER $PASSWORD`

if [ "$SID" == "" ]; then
   echo "Unable to establish session with AP at $ADDRESS"
   exit 1
fi

FORM_DATA="opcode=smb&sid=${SID}&${FORM_DATA}&restResource=${OPERATION}SshSesame&restMethod=GET"

echo "FORM_DATA=${FORM_DATA}"

curl -s -L -k -d "$FORM_DATA" "https://${ADDRESS}:4343/swarm.cgi"

chmod 400 OfficeConnectAP_Apr2017_rsa.dat

/usr/bin/expect -c "spawn ssh -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -i OfficeConnectAP_Apr2017_rsa.dat ${ADDRESS};
set timeout 300;
expect \"~ #\";
send \"/usr/sbin/wget https://hpe-officeconnect-firmwares.s3.amazonaws.com/OfficeConnectPortal_OC20_1.2.1_74212\n\";
expect \"#\";
send \"mv OfficeConnectPortal_OC20_1.2.1_74212 /tmp/mips.ari.flash \n\";
expect \"#\";
send \"write_flash 2\n\";
expect \"#\";
send \"write_flash 1\n\";
expect \"#\";
send \"reboot\n\";
expect \"#\";"
